package container

import (
	"fmt"
	"github.com/go-xorm/xorm"
	"testing"
)

func TestTransactionHandler_New(t *testing.T) {

	xormSession := &xorm.Session{}
	transactionHandler, err := NewTransactionHandler(xormSession)
	if err != nil {
		t.Fatalf("意外错误:%s", err.Error())
	}
	if transactionHandler == nil {
		t.Fatalf("创建失败!")
	}
	defaultTransactionHandler, ok := transactionHandler.(*DefaultTransactionHandler)
	if !ok {
		t.Fatalf("创建结果类型不正确!")
	}
	if defaultTransactionHandler.session != xormSession {
		t.Fatalf("会话设置错误")
	}
}

func TestTransactionHandler_New_NullSession(t *testing.T) {

	_, err := NewTransactionHandler(nil)
	if err == nil {
		t.Fatalf("意外的没有错误!")
	}
	if err.Error() != fmt.Sprintf("会话不能为空!") {
		t.Fatalf("意外错误:%s", err.Error())
	}
}
